#!/usr/bin/perl -i
#
#            
#          

#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#        Retract on layer change  
#        ,      Gcode
#  Only retract when crossing perimeters   
#       Custom G-code,   After layer change G-code 
#  Gcode: G92 E0
#        
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

# G1 Z ,    ,      
#  G1 Z, 
#G1 E4.00000  -4    ,   3   
#   G1 E4.0000  G92 E0,    
# G92 E0 -   
# G92 E0 -    

#          0D 0A
#       , 0A 0A

#     Z=0.100

#      
# perl -d d:\Reverse_script.pl d:\Etalon.gcode

#       Notepad++,    
# ->_,      :
# C:\Strawberry\perl\bin\perl.exe -d "$(FULL_CURRENT_PATH)" D:\Etalon.gcode
#            
#  ,      Perl  

#       
# DB<1>b num   num  ,     		152
# DB<2>c             
# DB<3>s	       


#c:\Strawberry\Slic3r_scripts\Extrusion_script.pl

use strict;
use warnings;
use Data::Dumper;

my $HANDLE=@ARGV[0]; 					#    13 ,    ARGV[0], ..    print(length(@ARGV[0]));
										#  print($HANDLE);          @ARGV[0]

my $LayerNumWhenScriptStart=0;			#        GCode
my $SearchValue = "G92 E0";				#    ,      

my $Is_even=1;							#  ,          										
my $ArraySSize= 0;						#      @Strings
my $ArrayESize= 0;						#      @E_values

#      [],      ,      1,  (),       0
my @Strings=();							#  ,      
my @E_values=();						#   E       
my @F_values=();						#        F	
my @Tmp=();								#          		
																	
my $E_value= 0.00000;
my $F_value= 0;
my $Fmaximal=0;							#     
my $AfterE='';							#         E

my $FilePos=0;							#      
my $FilePosNext=0;						#        
my $CharPos=0;							#   E   
my $String='';							#  
my $SumStrings='';						#    ,          ,    
my $EriserString='';					#             
my $SpacersNum=0;						#      $EriserString

my $G1Z =0;								# 
my $RetractCount=0;
my $AfterSkirt=0;
my $i=0;
my $i1=0;
my $i2=0;
my $NumRun=0;							#          ,        
my $N=0;								#         
my $FerstMaximal=1;						# ,    
my $PrintBefore=0;						#            ,       

open FILE, "+< $HANDLE";
print("File opened \n");

$LayerNumWhenScriptStart++;				#   "G1 Z",    

while (<FILE>) 
{ #       
	if (/G1 Z/)
		{
		$G1Z++;							#     "G1 Z"
		$Is_even= $Is_even*(-1);
		$RetractCount=0;
		$NumRun=0;
		$FilePos=0;
		$SumStrings='';
		$ArraySSize=0;
		$ArrayESize=0;
		}
	if(/$SearchValue/) 					#     "G92 E0"
		{
		$RetractCount++;
		}
#______________________________________________________________________________________________________________________________________________________
#         
#______________________________________________________________________________________________________________________________________________________
	if(($G1Z>$LayerNumWhenScriptStart) && ($RetractCount==1) && ($Is_even<0)) 	#     ,     Z,
																				#      .
																				#     .
																				#     2 
		{
		$String=$_;							#   
		push(@Strings, $String);
		$ArraySSize++;						#     @Strings  1   ;  
		#print ("Layer num = ($G1Z-1) \nArraySSize = $ArraySSize  \n");
			if($FilePos==0)					#       
				{
				$FilePos=tell(FILE);
				$FilePos= $FilePos-length($String)-1;
				}
		if(/G1/ && /E/)		#  ,    
			{
			$CharPos=index($String, 'E')+1;
			$E_value=substr($String,$CharPos,length($String));
			$E_value=$E_value+0;								#       ,     
			$E_value =sprintf("%s", $E_value);					#        string
			#print("E_value =$E_value \n");
			push(@E_values, $E_value);
			$ArrayESize++;					#     @E_values  1  ;  
			#print ("Layer num = $G1Z-1 \nArrayS = $ArraySSize  \nArrayE = $ArrayESize \n");
			}
		}
#______________________________________________________________________________________________________________________________________________________
#   F  E       
#______________________________________________________________________________________________________________________________________________________
	if(($G1Z>$LayerNumWhenScriptStart) && ($RetractCount==2) && ($Is_even<0) && ($NumRun==0)) 	#    ,   
																								#       
																								#        
		{
		$NumRun=1;								#        1   
		$FilePosNext=tell(FILE);				#      ,      
		
		#    N    
		#    N     $Strings
		#     X  Y,  E  F, 
		#      F  E
		$i=0;
		$N=0;
		while ($i==0)	#        
			{
			$String = $Strings[$N+1];	# ..     X  Y
			#print("String =$String \n");
			if (index($String, 'X')!=-1 && index($String, 'Y')!=-1)
				{
				$N++;
				}
			else
				{
				$i=1;
				}
			}
		#print("N =$N \n");		;  
		for($i=1;$i<=$N;$i++)	#   F   N  ,  
			{
			$String = $Strings[$i];
			$CharPos=index($String, 'F');
			$F_value=substr($String,$CharPos,length($String));	
			#print("String =$String \nF_value =$F_value \n");
			push(@F_values, $F_value);
			}
		$Fmaximal=$F_values[0];	#    
		$CharPos=index($Fmaximal, 'F');
		$Fmaximal=substr($Fmaximal,$CharPos+1,length($Fmaximal));
		$Fmaximal=$Fmaximal+0;
#______________________________________________________________________________________________________________________________________________________
#    F  E       
#______________________________________________________________________________________________________________________________________________________			
		$i=1;
		$i1=0;
		while($i<=$N)			#      
			{
			$i1++;
			$String = $Strings[$ArraySSize-$i1-1];
			if (index($String, 'X')!=-1 && index($String, 'Y')!=-1 && index($String, 'E')!=-1)
				{
				$CharPos=index($String, 'E');
				$E_value=substr($String, $CharPos, length($String));		#   E, ..      ,         
				$F_value=shift(@F_values);									#    F   
				substr($String,$CharPos,length($F_value),$F_value);			#  E  F   
				if (length($E_value)>length($F_value))						#      
					{
					$i2 = length($E_value)-length($F_value);
					$String = substr($String,0,length($String)-$i2);
					}
				$Strings[$ArraySSize-$i1-1]= $String;						#      
				reverse(@F_values);
				push(@F_values, $E_value);									#   E   ,   
				reverse(@F_values);
				$i++;
				}
			}
			
		for($i=1;$i<=$N;$i++)	#      
			{
			$String = $Strings[$i];									#     
			$CharPos=index($String, 'F');
			$F_value=substr($String, $CharPos, length($String));
			$E_value=shift(@F_values);									#    E  
			substr($String,$CharPos,length($E_value),$E_value);			#  F  E  
			if (length($F_value)>length($E_value))						#  ,    
					{
					$i2 = length($F_value)-length($E_value);
					$String = substr($String,0,length($String)-$i2);
					}
			#print("String =$String \n");
			$Strings[$i]= $String;									#      
			}		# ;  
#______________________________________________________________________________________________________________________________________________________
#        ,        G code
#______________________________________________________________________________________________________________________________________________________
		#     N+2    ,  N          2,   N+2
		#          N ,    N        
		for($i=0;$i<=($N+1);$i++)
			{
			$String = shift(@Strings);
			push(@Tmp, $String);
			}	
		$E_value = shift(@Tmp);			#    
		$String = pop(@Tmp);			#    
		@Tmp=reverse(@Tmp);				#      Tmp,     
		push(@Tmp, $String);			#     
		push(@Tmp, $E_value);			#     
		@Tmp=reverse(@Tmp);				#      Tmp ,     
		#for($i=0;$i<=($N+1);$i++)		#    
		#	{
		#	$String = shift(@Tmp);
		#	print ("String = $String \n");
		#	}		
		@Strings=reverse(@Strings);		#   @Strings,          @Tmp
		for($i=0;$i<=($N+1);$i++)
			{
			$String = pop(@Tmp);		#     Tmp
			#print ("String = $String \n");
			push(@Strings, $String);	#     Tmp    Strings
			}
		@Strings=reverse(@Strings);
		
		for($i=0;$i<=$N;$i++)
			{
			$String = pop(@Strings);
			push(@Tmp, $String);
			}
		@Tmp=reverse(@Tmp);
		$String = pop(@Tmp);			#    
		@Tmp=reverse(@Tmp);
		push(@Tmp, $String);			#    
		@Tmp=reverse(@Tmp);
		#for($i=0;$i<=$N;$i++)			#    
		#	{
		#	$String = shift(@Tmp);
		#	print ("String = $String \n");
		#	}
		for($i=0;$i<=$N;$i++)			#    @Strings
			{
			$String = shift(@Tmp);
			push(@Strings, $String);
			}
			
		$String="G92 E0\n";						# ..  $RetractCount==2  ,           
		push(@Strings, $String);
		$ArraySSize++;							#  
#______________________________________________________________________________________________________________________________________________________	
#        
#______________________________________________________________________________________________________________________________________________________		
		for($i=0;$i<=$ArraySSize-1;$i++)			#    Strings
			{
			$String = $Strings[$i];
			#print("String =$String \n");
			if (index($String, 'F')!=-1)			#    ,  
				{
				$CharPos=index($String, 'F');
				$F_value=substr($String,$CharPos+1,length($String));
				$F_value=$F_value+0;
				#print("F_value =$F_value \n");
				if ($F_value!=$Fmaximal)				#     ,   ,    
					{
					if (index($String, 'X')!=-1 && index($String, 'Y')!=-1 && index($String, 'E')!=-1 && index($String, 'F')!=-1)
						{
						$E_value=$F_value;				#   F   
						$CharPos=index($String, 'F');
						$String=substr($String,0,$CharPos-1);
						substr($String,length($String),1,"\n");
						$Strings[$i]=$String;
						}
					}
				}
			}
		for($i=0;$i<=$ArraySSize-1;$i++)			#    Strings		!!!! 
			{
			$String = $Strings[$i];
			if (index($String, 'F')!=-1)			#    ,  
				{
				$CharPos=index($String, 'F');
				$F_value=substr($String,$CharPos+1,length($String));
				$F_value=$F_value+0;
				#print("F_value =$F_value \n");
				if ($F_value==$Fmaximal && $PrintBefore==1)			#         G-code ,   
					{
					$F_value=" F";
					substr($F_value,length($F_value),length($E_value),$E_value);
					substr($F_value,length($F_value),1,"\n");
					#print("F_value =$F_value \nString = $String\n");
					$String = $Strings[$i-1];
					substr($String,length($String)-1,length($F_value),$F_value);
					$Strings[$i-1]=$String;
					$String = $Strings[$i-6];
					if (index($String, 'F')==-1)
						{
						substr($String,length($String)-1,length($F_value),$F_value);
						$Strings[$i-6]=$String;
						print("Strings[i-1] =$Strings[$i-1]\nStrings[i-6] = $Strings[$i-6]\n");
						}
					}
				$PrintBefore=0;
				}
			if (index($String, 'X')!=-1 && index($String, 'Y')!=-1 && index($String, 'E')!=-1)
				{
				$PrintBefore=1;
				}
				
			if (index($String, 'X')==-1 && index($String, 'Y')==-1 && index($String, 'E')!=-1 && index($String, 'F')!=-1)	#     
					{
					if ($FerstMaximal==1)
						{
						$FerstMaximal=0;
						}
					else
						{
						$F_value=" F";
						substr($F_value,length($F_value),length($E_value),$E_value);
						substr($F_value,length($F_value),1,"\n");
						$String = $Strings[$i-1];
						substr($String,length($String)-1,length($F_value),$F_value);
						print("F_value =$F_value \nString = $String\n");
						$Strings[$i-1]=$String;
						$String = $Strings[$i-6];
						if (index($String, 'F')==-1)
							{
							substr($String,length($String)-1,length($F_value),$F_value);
							$Strings[$i-6]=$String;
							print("Strings[i-2] =$Strings[$i-2]\nStrings[i-6] = $Strings[$i-6]\n");
							}
						}
					}
			}
#______________________________________________________________________________________________________________________________________________________	
#       X, Y  E     
#______________________________________________________________________________________________________________________________________________________	
		for($i=($ArraySSize-1);$i>=0;$i--)		#  ,       X , Y  E
			{
			$String = pop(@Strings);			#       @Strings,  
			#print ("String =$String");
			
			if (index($String, 'E')==(-1))		#          
				{
				substr($SumStrings,length($SumStrings),length($String),"$String");
				#print ("SumStrings =$SumStrings");
				#substr($SumStrings,length($SumStrings)-1,2," ");			#        ,      
				}
			else								#   ,    E
				{
				if (index($String, 'G1')!=-1)	#     'G1'
					{
					$CharPos=index($String, 'E')+1;
					$E_value=substr($String,$CharPos,length($String));
					$AfterE= $E_value;																#        E
					$E_value=$E_value+0;															#   
					$AfterE= substr($AfterE,length($E_value),length($AfterE)-length($E_value));		#       
					$i1 =index($AfterE, ' ');
					if ($i1!=-1) 																	#   $AfterE,     ".00000"      
						{
						$AfterE= substr($AfterE,$i1,length($AfterE)-$i1);
						}
					#$E_value = $E_values[$i1];														#        ;  ,    
					$E_value =shift(@E_values);														#           @E_values,  

					$E_value ={$E_value};									#        
					$E_value =Dumper $E_value;								#   E       "$VAR1 ={'4'=> undef};"
					$i1=index($E_value, '\'')+1;							#       $E_value
					$E_value =substr($E_value,$i1,length($E_value)-$i1);
					$i1=index($E_value, '\'');
					$E_value =substr($E_value, 0, $i1);
					
					#print ("E_value = $E_value \n");
					#     $E_value= $E_value + $AfterE      $AfterE      $E_value
					substr($E_value,length($E_value),length($AfterE),$AfterE);						#     E
					substr($String,$CharPos,length($String)-1,$E_value);							#    
					#$SumStrings=$SumStrings+$String;	#  ,    
					substr($SumStrings,length($SumStrings),length($String),"$String");
					#print $SumStrings;
					}
				else							#     
					{
					substr($SumStrings,length($SumStrings),length($String),"$String");
					}
				}
			#print ("SumString = $SumStrings \n");
			if ($i==0)											#    ,      ";"   ,
																#          
				{
				#$SpacersNum=$FilePosNext-$FilePos-6;
				$SpacersNum=$FilePosNext-$FilePos-1;
				#print ("SpacersNum = $SpacersNum\nFilePos = $FilePos\nFilePosNext = $FilePosNext\n");
				$SpacersNum=$SpacersNum-length($SumStrings)-1;	#   ,        
				$i1 = length($SumStrings)-1;
				#print ("SpacersNum = $SpacersNum\nlength(SumStrings)-1 = $i1\n");
				$EriserString=';';
				for($i1=1;$i1<=$SpacersNum;$i1++)				#  - 
					{
					substr($EriserString,length($EriserString),1," ");
					}
				substr($SumStrings,length($SumStrings)-1,length($EriserString),$EriserString);
				}				
			}
		#print ("SumString = $SumStrings \n");
		seek(FILE,$FilePos,0);									#         
		syswrite(FILE, $SumStrings, length($SumStrings) );		#       	
		seek(FILE,$FilePosNext,0);								#          
		#splice(@Strings, $ArraySSize-1, $ArraySSize);			#    
		#splice(@E_values, $ArrayESize-1, $ArrayESize);
		}
}